<?php
/*  Copyright 2009  Alexandre Hoyau  (email : lex [at] silex-ria . org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
/**
 * @package exchange-platform
 * @author http://lex.silex.tv/
 * @version 1
 */
require_once(EP_PLUGIN_DIR.'/includes/EPItemData.php');

/**
 * make the feeds available with url rewrite
 */
function silex_rewrite_rules( $wp_rewrite ) {
  $new_rules = array(
    'feed/(.+)' => 'index.php?feed='.$wp_rewrite->preg_index(1)
  );
  $wp_rewrite->rules = $new_rules + $wp_rewrite->rules;
}
/**
 * declare the feeds for listing of the categories, tags, ...
 */
function silex_add_feeds() {
  // global $wp_rewrite;
  // add feeds
  add_feed('ep_child_categories', 'ep_child_categories');
  add_feed('ep_posts_in_category', 'ep_posts_in_category');
  add_feed('ep_download', 'ep_download');
  add_feed('ep_get_item_info', 'ep_get_item_info');
//  add_feed('ep_tags_feed', 'ep_tags_feed');
//  add_feed('ep_pages_feed', 'ep_pages_feed');
//  add_feed('ep_bookmarks_feed', 'ep_bookmarks_feed');
//  add_feed('ep_paged_feed', 'ep_paged_feed');

  // add rewrite rule action
  add_action('generate_rewrite_rules', 'silex_rewrite_rules');
}
add_action('init', 'silex_add_feeds');

// flush_rules outside of init for performance reasons : http://codex.wordpress.org/Rewrite_API/flush_rules
function silex_flush_rules_feeds() {
	global $wp_rewrite;
	$wp_rewrite->flush_rules();
}
add_action('publish_post', 'silex_flush_rules_feeds');

// ?feed=ep_get_item_info&p=648&format=rss2
function ep_get_item_info()
{
	// new EPItemData
	$epItemData = new EPItemData();
	
	// get the post ID
	$id = $_GET['p'];

	// display as RSS
	// print_r($epItemData->getChildCategories($id),false);
	EPItemData::echoAsRSS(array($epItemData->getInfo($id)));
}
// ?feed=ep_child_categories&cat=5&format=rss2
function ep_child_categories()
{
	// new EPItemData
	$epItemData = new EPItemData();
	
	// get the category parent ID
	if (isset($_GET['cat']))
		$id = $_GET['cat'];
	else
		$id = '0';

	// display as RSS
	// print_r($epItemData->getChildCategories($id),false);
	EPItemData::echoAsRSS($epItemData->getChildCategories($id));
}
// ?feed=ep_posts_in_category&cat=5&format=rss2&posts_per_page=10&paged=5
function ep_posts_in_category()
{
	// new EpItemData
	$epItemData = new EPItemData();
	
	// get the category parent ID
	if (isset($_GET['cat']))
		$id = $_GET['cat'];
	else
		$id = '0';

	// get the category parent ID
	if (isset($_GET['posts_per_page']))
		$itemsPerPage = $_GET['posts_per_page'];
	else
		$itemsPerPage = '0';

	// get the category parent ID
	if (isset($_GET['paged']))
		$pageNumber = $_GET['paged'];
	else
		$pageNumber = '0';

	// display as RSS
	// print_r($epItemData->getChildCategories($id),false);
	EPItemData::echoAsRSS($epItemData->getPostsInCategory($id,$itemsPerPage,$pageNumber),$epItemData->getPostsCountInCategory($id));
}
// ?feed=ep_download&p=648&file=version.xml
function ep_download()
{
	$epConfig = new EPConfig();
	$epConfig->loadConfig();
	
	$epItemFiles = new EPItemFiles();
	$postID = $_GET['p'];
	$filePath = $epItemFiles->getItemFolderPath($epConfig->epSecureOfflineFolderDir,$postID) . '/' . $_GET['file'];
	
	if( is_file( $filePath ) )
	{
		// Turn off error reporting so that we avoid file corrupted by notice outputs
		error_reporting(0);
		
		// No Apache g-zip compression (it would shortcut our buffering here)	[doesn't seem to work]
		//@apache_setenv('no-gzip', 1);
		//@ini_set('zlib.output_compression', 0);
		
		// Start output buffering
		ob_start();
		
		// Clean buffer before doing anything
		ob_clean();
		
		// Set response headers
		header('Content-Description: File Transfer');
		header('Content-Type: application/octet-stream');
		header("Content-Type: application/force-download");
		header('Content-Disposition: attachment; filename='.basename( $filePath ));
		header('Content-Transfer-Encoding: binary');
		header('Expires: 0');
		header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
		header('Pragma: public');
		header('Content-Length: ' . filesize(SILEX_FILES_ROOT.$filePath));
		
		// read/send loop
		$fp = fopen($filePath, 'rb');
		while ($buffer = fread($fp, 1024))
		{
			echo $buffer;
			ob_flush();
			flush();
		}
		fclose($fp); 
		
		// End output buffering
		ob_end_flush();
	}
}

?>